#region Copyright Syncfusion Inc. 2001 -2004
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
//  Copyright Syncfusion Inc. All rights reserved. Use of this code is subject to the terms of our 
//  license. A copy of the current license can be obtained at any time by e-mailing licensing@syncfusion.com. 
//  Re-distribution in any form is strictly prohibited. Any infringement will be prosecuted under applicable laws. 
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
#endregion 
 
using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Chart;

namespace Syncfusion.Windows.Forms.Chart.Samples
{
	/// <summary>
	/// The ChartControl sample form.
	/// </summary>
	public class FormMain : Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		
		private Syncfusion.Windows.Forms.Chart.ChartControl chartControl1;
		private Syncfusion.Windows.Forms.BorderPanel borderPanel1;
		private ChartAxis secXAxis = new ChartAxis();

		public FormMain()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(FormMain));
			
			this.chartControl1 = new Syncfusion.Windows.Forms.Chart.ChartControl();
			this.borderPanel1 = new Syncfusion.Windows.Forms.BorderPanel();
			this.SuspendLayout();
			
			// 
			// chartControl1
			// 
			this.chartControl1.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(237)), ((System.Byte)(240)), ((System.Byte)(247)));
			this.chartControl1.LegendPosition = Syncfusion.Windows.Forms.Chart.ChartLegendPosition.Top;
			this.chartControl1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.chartControl1.Name = "chartControl1";
			this.chartControl1.PrimaryXAxis.Orientation = System.Windows.Forms.Orientation.Horizontal;
			this.chartControl1.ShowToolTips = true;
			this.chartControl1.Size = new System.Drawing.Size(522, 344);
			this.chartControl1.TabIndex = 1;
			this.chartControl1.Text = "Essential Chart";
			// 
			// borderPanel1
			// 
			this.borderPanel1.Background = new Syncfusion.Drawing.BrushInfo(System.Drawing.Color.FromArgb(((System.Byte)(42)), ((System.Byte)(67)), ((System.Byte)(126))));
			this.borderPanel1.Control = this.chartControl1;
			this.borderPanel1.Dimensions.All = 15;
			this.borderPanel1.Dimensions.Bottom = 15;
			this.borderPanel1.Dimensions.Left = 15;
			this.borderPanel1.Dimensions.Right = 15;
			this.borderPanel1.Dimensions.Top = 15;
			this.borderPanel1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.borderPanel1.InnerColor = System.Drawing.Color.FromArgb(((System.Byte)(192)), ((System.Byte)(192)), ((System.Byte)(255)));
			this.borderPanel1.InnerCornerRadius.All = 10;
			this.borderPanel1.InnerCornerRadius.BottomLeft = 10;
			this.borderPanel1.InnerCornerRadius.BottomRight = 10;
			this.borderPanel1.InnerCornerRadius.TopLeft = 10;
			this.borderPanel1.InnerCornerRadius.TopRight = 10;
			this.borderPanel1.InnerState = Syncfusion.Windows.Forms.BorderPanelState.Level;
			this.borderPanel1.Name = "borderPanel1";
			this.borderPanel1.Size = new System.Drawing.Size(552, 374);
			this.borderPanel1.TabIndex = 0;
			// 
			// FormMain
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(552, 374);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.borderPanel1});

			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "FormMain";
			this.Text = "Essential Chart - Chart Multiple Axes Sample";
			this.Load += new System.EventHandler(this.FormMain_Load);
			
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new FormMain());
		}

		
		private void FormMain_Load(object sender, System.EventArgs e)
		{
			// Specify a ChartPalette
			this.chartControl1.Model.ColorModel.Palette = ChartColorPalette.Triad;

			InitializeChartData();
			InitializeChartAppearance();
		}

		/// <summary>
		/// Initializes the ChartControl's data and sets the Chart type
		/// </summary>
		protected void InitializeChartData()
		{
			int numSeries = 2;
			int numPoints = 10;

			Random random = new Random();
			for(int i = 0; i < numSeries; i++)
			{
				ChartSeries series = this.chartControl1.Model.NewSeries("Series " + i);
				if(i == 0)
				{
					for(int j = 0; j < numPoints; j++)
					{
						series.Points.Add(j+1, (double)random.Next(400, 500));
					}
				}
				else
				{
					for(int j = 0; j < numPoints; j++)
					{
						series.Points.Add(j+1, (double)random.Next(100, 200));
					}
				}
				series.Type = ChartSeriesType.Line;
				series.PrepareStyle += new ChartPrepareStyleInfoHandler(this.ChartControlSeries_PrepareStyle);
				series.Text = series.Name;

				if(i == 1)
				{
					this.chartControl1.Axes.Add(this.secXAxis);
					this.secXAxis.RangeType = ChartAxisRangeType.Auto;
					this.secXAxis.ValueType = ChartValueType.Double;
					this.secXAxis.OpposedPosition = true; // will be positioned opposite the regular axis
					this.secXAxis.Orientation = Orientation.Vertical;
					series.YAxis = this.secXAxis;
				}
				this.chartControl1.Series.Add(series);
			}
		}

		/// <summary>
		/// Sets properties to customize the ChartControl's appearance
		/// </summary>
		protected void InitializeChartAppearance()
		{
			// We don't use indexed mode with multiple axes.
			this.chartControl1.Indexed = false;
			this.chartControl1.LegendPosition = ChartLegendPosition.Top;

			// add the second axis
//			this.chartControl1.Axes.Add(this.secXAxis);
		//	this.secXAxis.RangeType = ChartAxisRangeType.Auto;
//			this.secXAxis.ValueType = ChartValueType.Double;
//			this.secXAxis.Range = new MinMaxInfo(100, 200, 20);
//			this.secXAxis.OpposedPosition = true; // will be positioned opposite the regular axis
//			this.secXAxis.Orientation = Orientation.Vertical;

			// set the style of each of the series.
			this.chartControl1.Series[0].Style.Border.Color = Color.FromArgb(100, Color.BlueViolet);
			this.chartControl1.Series[0].Style.Border.DashStyle = DashStyle.DashDotDot;

			// Use the second X axis
			this.chartControl1.Series[1].Style.Border.Color = Color.FromArgb(100, Color.Red);
			this.chartControl1.Series[1].Style.Border.DashStyle = DashStyle.DashDotDot;
//			this.chartControl1.Series[1].YAxis = this.secXAxis;

		}

		/// <summary>
		/// Handler for the PrepareStyle event of ChartSeries. 
		/// </summary>
		/// <param name="sender">The ChartSeries object that raises this event.</param>
		/// <param name="args">The event data. Can be modified to change series appearance.</param>
		protected void ChartControlSeries_PrepareStyle(object sender, ChartPrepareStyleInfoEventArgs args)
		{
			// Style formatting using a callback. You can apply the same settings directly on the series style on the
			// point styles.
			ChartSeries series = sender as ChartSeries;
			if(series != null)
			{
				args.Style.Text = string.Format("Value is {0}", series.Points[args.Index].YValues[0]);
				args.Style.TextOrientation = ChartTextOrientation.Center;
				args.Style.Symbol.Size = new Size(15,15);
				args.Style.Symbol.Color = Color.Red;
				args.Style.DisplayShadow = true;

				if(series == this.chartControl1.Series[0])
					args.Style.Symbol.Shape = ChartSymbolShape.Cross;
				else
					args.Style.Symbol.Shape = ChartSymbolShape.Circle;

			}
		}


		
	}
}
